#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(255,240,240);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	myFont.loadFont("GothamHTF-Bold.otf", 300, true,true,true);
    letter = 'T';
    testChar = myFont.getCharacterAsPoints(letter);
    
    ofPolyline line;
    for(int k = 0; k < 1; k++){
        //if( k!= 0)ofNextContour(true) ;
        for(int i = 0; i < (int)testChar.getOutline()[k].size(); i++){
            ofPoint pos;
            pos.x = testChar.getOutline()[k].getVertices()[i].x;
            pos.y = testChar.getOutline()[k].getVertices()[i].y;
            line.addVertex(pos);
        }
    }
	line.addVertex(testChar.getOutline()[0][0]);
    
    ofPolyline lineResampled = line.getResampledBySpacing(10);
    
    
    ofSetColor(255);
    
    
    lineResampled.draw();
    for (int i = 0; i < lineResampled.getVertices().size(); i++){
        float x = ofGetWidth()/2 + lineResampled.getVertices()[i].x;
		float y = ofGetHeight()/2 + lineResampled.getVertices()[i].y;
		particle myParticle;
		myParticle.setInitialCondition(x,y,0,0);
		particles.push_back(myParticle);
    }
    
    
	
	
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 10;
		mySpring.springiness	= 0.3f;
		mySpring.particleA = & (particles[i]);
		mySpring.particleB = & (particles[(i+1)%particles.size()]);
		springs.push_back(mySpring);
	}
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		float dist = (particles[i].pos - particles[(i+10)%particles.size()].pos).length();
		mySpring.distance		= dist;
		mySpring.springiness	= 0.2f;
		mySpring.particleA = & (particles[i]);
		mySpring.particleB = & (particles[(i+10)%particles.size()]);
		springs.push_back(mySpring);
	}
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		float dist = (particles[i].pos - particles[(i+20)%particles.size()].pos).length();
		
		mySpring.distance		= dist;
		mySpring.springiness	= 0.05f;
		mySpring.particleA = & (particles[i]);
		mySpring.particleB = & (particles[(i+20)%particles.size()]);
		springs.push_back(mySpring);
	}
	
	//particles[particles.size()-1].bFixed = true;
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addForce(0,0.1);
		particles[i].addRepulsionForce(mouseX, mouseY, 300, 1.5);
	}
	 
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
	}
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	

	ofSetColor(100,100,100);
	ofFill();
	//ofBeginShape();
	for (int i = 0; i < particles.size(); i++){
		///ofVertex(particles[i].pos.x, particles[i].pos.y);
		particles[i].draw();
	}
	//ofEndShape(true);
	
//	for (int i = 0; i < springs.size(); i++){
//		springs[i].draw();
//	}


}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
    
    testChar = myFont.getCharacterAsPoints(key);
	letter = key;
    
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles[0].pos.set(mouseX, mouseY);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	particles[0].bFixed = false;
}

